function CheckInGrid(i,j){
 if (i+j <= gridSide-2) {return false}
 if (i >= (2*gridSide) -1) {return false}
 if (j >= (2*gridSide) -1) {return false}
 if (i+j > (gridSide-1)*3) {return false}
 if (i<0 || j<0) {return false}
 else {return true};

}
function neighbourSwitch(n){
switch(n){
case 0:
return[1,-1];
break;
case 1:
return[1,0];
break;
case 2:
return[0,1];
break;
case 3:
return[-1,+1];
break;
case 4:
return[-1,0];
break;
case 5:
return[0,-1];
break;
}
}

function getNeighbours(i,j){
  let results = [];
  results[0]=[i+1,j-1];
  results[1]=[i+1,j];
  results[2]=[i,j+1];
  results[3]=[i-1,j+1];
  results[4]=[i-1,j];
  results[5]=[i,j-1];
  return results;
}

function getNeighboursAsHexes(i,j){
let results = [];
let places=getNeighbours(i,j);
for (let i =0; i<places.length; i++){
  results[i]=null;
  checkI=places[i][0];
  checkJ=places[i][1];
  if (CheckInGrid(checkI, checkJ)){
    results[i]=hexagons[checkI][checkJ];
}
}
  return results;
}
function getDistantNeighboursAsHexes(i,j,n){
  //n is hex separation- 1 is next door, 2 is the next ring..
let results = [];
let places=getNeighbours(0,0);
let checkI=(-1*n)+i;
let checkJ=j;

for (let a=0; a<6; a++){
  for (let b=0; b<n; b++){
    checkI=checkI+(places[a][0]);
    checkJ=checkJ+(places[a][1]);

    if (CheckInGrid(checkI, checkJ)){
      results.push(hexagons[checkI][checkJ]);
  }
}
}
//console.log('results ', results);
  return results;
}

function getLineBuddies(hexAi, hexAj, hexBi, hexBj){
  //gets all the hexes in a line from a to b
let dI=hexBi-hexAi;
let dJ=hexBj-hexAj;
let sI=Math.sign(dI);
let sJ=Math.sign(dJ);
//console.log(hexAi, hexAj, hexBi, hexBj, dI,dJ);
let maxStep=max(abs(dI),abs(dJ));
//console.log('max step', maxStep);
//if +i+j, -i-j or 0,0 we're not on a line
if ((dI!=dJ*-1)&&((sI*sJ)!=0)){
 // console.log('not in line');
  return -1;
}
let results=[];
//step through by the displacement and store each hex
//console.log('results', results);
for (let step=1; step<maxStep+1; step++){
  let stepI=step*sI;
  let stepJ=step*sJ;
let nI=hexAi+stepI;
let nJ=hexAj+stepJ;
//console.log(nI,nJ);
if (!CheckInGrid(nI,nJ)){
  //console.log ('out of grid');
  return -1;
}
  let testHex=hexagons[nI][nJ];
  if (testHex.live!=true || testHex.status != "neutral"){
   // console.log('hex not good');
    return -1;
  }
  results[step-1]=testHex;
}
//console.log(results);
return results;
}

function getHexDistances(start, end){
  //taxi cab distance between two hexes
  let dI=abs(end.i-start.i);
  let dJ=abs(end.j-start.j);
  return dI+dJ;
}


function cubeToAxial(i,j,k){
return [i,j];
}
function axialToCube(i,j){
 return [i,j,-i-j];
}
function cubeRound(i,j,k){
 var ri = round(i);
    var rj = round(j);
    var rk = round(k);
  let i_diff = abs(ri-i);
  let j_diff = abs(rj-j);
  let k_diff = abs(rk-k);

 if (i_diff > j_diff & i_diff > k_diff){
        ri = -rj-rk;}
    else if (j_diff > k_diff){
        rj = -ri-rk;}
    else{
        rk = -ri-rj;
    }
    return[ri,rj,rk];
}
function hexToPixel(i,j){
let x = floor((hexsize)*((sqrt(3)*i)+(sqrt(3)*(0.5*j))));
 let y = floor(hexsize)*j*3*0.5;
y+=gridYoff;
x+=gridXoff;
return[x,y];
}
function pixelToHex(x,y){

   y-=gridYoff;
   x-=gridXoff;


    var r = (y*2)/(3*(hexsize));
    var q = (x-(y/sqrt(3)))/(hexsize*sqrt(3));

    let qrcube=axialToCube(q,r);
    let qrsround = cubeRound(qrcube[0],qrcube[1], qrcube[2]);
    let qrround=cubeToAxial(qrsround[0],qrsround[1],qrsround[2]);

    return qrround;
}
function MakeHexPoints(x,y,size){
  let points = [];
for (let a = TWO_PI/12; a < TWO_PI; a += TWO_PI/ 6) {
    let x2 = cos(a) * size;
    let y2 = sin(a) * size;
   points.push(x + x2);
   points.push(y + y2);
}
return points;
}
function DrawHex(x,y,points,colour,strokeW, strokeC){
  fill(colour);
stroke(strokeC)
strokeWeight(strokeW);
beginShape();
  for (let count = 0; count < 12; count+=2){
    vertex(points[count], points[count+1]);
  }
  endShape(CLOSE);
}


class Hexagon {
  constructor(i,j,size){
     this.size=size;
    this.i=i;
    this.j = j;
    this.indexIJ=(i * (gridSide*2)-1) + j;
    this.letter = -1;
  let xy=hexToPixel(i,j);
  this.x=xy[0];
  this.y=xy[1];
    this.h=this.size*2;
    this.w=sqrt(3)*this.size;
    this.locarray=[i,j];
    this.colour=color(cols[floor(random(cols.length))]);
    this.colourBack=this.colour;
    this.stroke= 'black';
    this.strokeW= 4;
    this.points=[];
    this.points = MakeHexPoints(this.x,this.y, this.size);
    this.live=true;
    this.status="neutral";
    //console.log(this.points);
  }//end constructor

  show(){
    this.colourTemp=color(this.colour);
    //this.colourTemp.setAlpha(30);
    if (this.live==true){
    //this.colour = color(220);
    let testArray=pixelToHex(mouseX, mouseY*gridYsquish);
    if (testArray[0]==this.i && testArray[1]==this.j){
     this.colourTemp = color(255,255,128);
    this.stroke=gameP.whoseTurn.playerColour;
    this.strokeW=6;
   }else{
     this.stroke='black';
     this.strokeW=3;
   }
     //for (let zzz=0; zzz<6; zzz++){
     //  let nextIJ=neighbourSwitch(zzz);
     //  let nextI=nextIJ[0];
     //  let nextJ=nextIJ[1];
     //  if (testArray[0]==this.i+nextI && testArray[1]==this.j+nextJ){
     //  this.colour=color(255,128,255);
     //}
     //}

    DrawHex(this.x, this.y, this.points, this.colourTemp, this.strokeW, this.stroke);
    textAlign(CENTER, CENTER);
    textSize(48);
    //text(this.letter+", "+this.i+", "+this.j, this.x, this.y);
      // fill('black');
     //text(this.letter, this.x+2, this.y+2);
       fill('white');
       stroke('black');
       strokeWeight(3);
     text(this.letter, this.x, this.y);
    }}//end show

  clicked(){
  if (this.live){
  switch(this.status){
  case 'neutral':{
    gameP.whoseTurn.addHexLetter(this);
    gameMusicHandler.arpAdd(this.letter,gameMusicHandler.arpLength);
   // this.colour=color(gameP.whoseTurn.playerColour);
   // this.status="selected";
    break;
  }
  case 'selected':{
   //this.colour=this.colourBack;
   //this.status='neutral';
    gameP.whoseTurn.dropHexLetter(this)
    break;
  }
  case 'goodLanding':
  //console.clear();
  gameP.whoseTurn.destinations=[];
  gameP.whoseTurn.destinations.push([this.i, this.j]);
  for(let n=0; n<hexagons.length; n++){
    hexagons[n].forEach(h=>{
    if(h instanceof Hexagon)  {
      h.changeHexStatus('neutral');
    }
    });
  }
if(gameP.whoseTurn.status=='ending turn'){
  gameP.turnover();
}
  break;
  case 'notGoodLanding':
  break;

  }
  }//end if live
  }//end clicked

  changeHexStatus(newStatus){
this.status=newStatus;
switch(newStatus){
case 'selected':
this.colour=color(gameP.whoseTurn.playerColour);
break;
case 'neutral':
this.colour=this.colourBack;
break;
case 'goodLanding':
this.colour=color(gameP.whoseTurn.playerColour);
break;
case 'notGoodLanding':
this.colour=color('SlateGrey');
break;
}
}

}//end class

class Hexygrid {

  constructor(gridSide){
  //grid stuff
  this.gridSide=gridSide;
  this.gridLength = (2*gridSide)-1;
   //hexsize = floor(min(height,width)/(this.gridLength*1.25));
   this.gridDrawWidth= playerColourPick[playerColourPick.length-1].width+playerColourPick[playerColourPick.length-1].x+300;;
   this.gridDrawHeight=height-(150);
   let maxHexH=floor((this.gridDrawHeight*gridYsquish)/(this.gridLength));
   let maxHexW=floor(this.gridDrawWidth/((this.gridLength+1)*sqrt(3)));
//console.log(maxHexW, maxHexH);
//console.log(this.gridDrawWidth,this.gridDrawHeight);
   hexsize=min(maxHexH,maxHexW);
   //hexsize=floor(min(height*0.75,playerNameBox[playerNameBox.length-1].width+playerNameBox[0].y)/(this.gridLength));
   //gridYoff=floor(hexsize*6);
   gridYoff=((playerNameBox[0].height+playerNameBox[0].y+(hexsize))*gridYsquish);
   gridXoff=floor(hexsize*sqrt(3)*-0.5*(gridSide-2))+30;

   //reposition some buttons whilst we're doing dimensions
   checkWordButton.position((this.gridDrawWidth*0.5)-(checkWordButton.width*1.5),this.gridDrawHeight);
   clearButton.position((this.gridDrawWidth*0.5)+(checkWordButton.width*0.5),this.gridDrawHeight);

  //create hexes
  for (let i=0; i<this.gridLength; i++){
    hexagons[i]=[];
    for (let j=0; j<this.gridLength; j++){
      hexagons[i][j]=-1;
      if (CheckInGrid(i,j)){
  hexagons[i][j]= new Hexagon(i,j,hexsize);

  }
    }
  }
  this.wordList = getWordList(round(this.gridLength*(this.gridSide/2)));
  //console.log(this.wordList);
  //for (let debug = 0; debug<this.wordList.length; debug++){
  //console.log(this.wordList[debug]);
  //}
  this.wordList = assignGridLetters(this.wordList);
  for (let i = 0; i<hexagons.length; i++){
   for (let j = 0; j<hexagons.length; j++){
   if (hexagons[i][j].letter==-1){
  hexagons[i][j].letter=char(floor(random(97,97+25)));
//hexagons[i][j].live=false;
//  hexagons[i][j].letter="!!!";
   }
   }
  }
  this.backupWords=[];
  this.backupGrid();
  }//end constructor

  show(){
    strokeWeight(1);
    //line(0,this.gridDrawHeight,this.gridDrawWidth,this.gridDrawHeight);
    //line(this.gridDrawWidth,0,this.gridDrawWidth,this.gridDrawHeight);
    push();
    scale(1, 1/gridYsquish);
    //show hexes
    for (let i=0; i<hexagons.length; i++){
  for (let j=0; j<hexagons.length; j++){
  let h = hexagons[i][j];
  if (h!=-1){

    h.show();
  }
  }
}
pop();

//show word list
textAlign(LEFT, CENTER);
fill('white');
stroke('black');
strokeWeight(2);
textSize(32);
//textLeading(8);
let maxLines=floor((this.gridDrawHeight-72)/36);
let listX=this.gridDrawWidth+20;
//let listX=(this.gridLength*(hexsize*2))+gridXoff+75;
//let listX=playerColourPick[playerColourPick.length-1].x+playerColourPick[playerColourPick.length-1].width+(hexsize*sqrt(3)+30);
for (let listn=0; listn<this.wordList.length; listn++){
text(this.wordList[listn],listX+(floor(listn/maxLines)*120), 30+(listn*36)-(floor(listn/maxLines)*(maxLines*36)));
}
stroke('white');
  }//end show

backupGrid(){
for (let i=0; i<hexagons.length; i++){
  hexagonsBackup[i]=[];
  for (let j=0; j<hexagons.length; j++){
    let h = hexagons[i][j];
    hexagonsBackup[i][j]=h.letter;
  }}
  for (let n = 0; n<this.wordList.length; n++){
    this.backupWords.push(this.wordList[n]);
  }
}//end backup

resetGrid(){
  this.wordList=this.backupWords;
  for (let i=0; i<hexagons.length; i++){
  for (let j=0; j<hexagons.length; j++){
    let h = hexagons[i][j];
    if(h!=-1){
    h.letter=hexagonsBackup[i][j];
    h.live=true;
    h.status='neutral'
    h.colour=h.colourBack;
    }
  }}
}

checkWord(word){
  if (this.wordList.length!=0){
  return this.wordList.includes(word);
  }
  return false;
}
bigDictCheck(word){
  if(useBigDictionary){
    return bigdictionary.includes(word);
  }
  return false;
}

deleteWord(word){
  let i = this.wordList.indexOf(word);
  this.wordList.splice(i,1);
}

} //end class

function pathfind(start, end){
//  console.log('start ', start);
//  console.log('end ',end);
var frontier=[];
frontier.push([0, start]);
var cameFrom=new Array(HexGrid.gridLength*(HexGrid.gridLength+1));
var costSoFar=new Array(HexGrid.gridLength*(HexGrid.gridLength+1)).fill(-1);
cameFrom[start.indexIJ]=null;
costSoFar[start.indexIJ]=0;
//console.log('costSoFar',costSoFar);
var current = start;
frontierloop: while (frontier.length>0){
  frontier.sort(function(a,b){
return a[0]-b[0]
});
current=frontier.shift()[1];
//console.log(frontier);
//console.log('current', current);
if (current==end){
  //console.log ('got to end');
//  console.log (cameFrom);
  break frontierloop;
}
  var neighbours=getNeighboursAsHexes(current.i, current.j);
  //console.log('neighbours ',neighbours);
  neighbours.forEach(next =>{
    if (next && next.live){
    var newCost=costSoFar[current.indexIJ]+1;
    //console.log('next i, nex j, next index, new cost',next.i,next.j,next.indexIJ, newCost);
  //  console.log('costsofar of next', costSoFar[next.indexIJ]);
    if ((costSoFar[next.indexIJ]==-1)||newCost<costSoFar[next.indexIJ]){
      costSoFar[next.indexIJ]=newCost;
      let priority = newCost + getHexDistances(next, end);
      frontier.push([priority, next]);
    //  console.log('frontier', frontier);
      cameFrom[next.indexIJ]=current;
    }
  }
  });
}
//abort if didn;t get to end
if (cameFrom[end.indexIJ]==undefined){
  //console.log('didnt get to end')
  return false;
}
//get the actual path
var resultQ=[];
current=end;
while(current !=start){
resultQ.push([current.i, current.j]);
current=cameFrom[current.indexIJ];
}
//console.log('results', resultQ)
return resultQ;
}
